#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	abseil-cpp
Version		:	20240116.2
Release		:	17.2.0.rel%{?dist}
Summary		:	Collection of C++ library code designed to augment the C++ standard library

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	Apache-2.0
URL		:	https://github.com/abseil/abseil-cpp/

Source0		:	%{name}-%{version}.tar.gz
Patch0		:	%{name}-%{version}-scoped-mock-log.patch

#-----------------------------------------------------------------------------
BuildRequires	:	cmake
BuildRequires	:	gcc
BuildRequires	:	gcc-c++
BuildRequires	:	gmock-devel
BuildRequires	:	gtest-devel
BuildRequires	:	make

#-----------------------------------------------------------------------------
%description
Abseil is an open-source collection of
C++ library code designed to augment the
C++ standard library. The Abseil library
code is collected from Google's own C++
code base, has been extensively tested and
used in production, and is the same code
we depend on in our daily coding lives.

In some cases, Abseil provides pieces
missing from the C++ standard; in others,
Abseil provides alternatives to the standard
for special needs we've found through usage
in the Google code base. We denote those cases
clearly within the library code we provide you.

#-----------------------------------------------------------------------------
%files
%defattr(-, root,root,-)
%license LICENSE
%{_libdir}/libabsl_*.so
	
#=============================================================================
%package		devel

Summary		:	development files for %{name}

#-----------------------------------------------------------------------------
Requires	:       %{name} = %{version}-%{release}
Requires	:       gmock

#-----------------------------------------------------------------------------
%description		devel
This package contains development files for %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/absl/algorithm/*.h
%{_includedir}/absl/base/internal/*.inc
%{_includedir}/absl/base/internal/*.h
%{_includedir}/absl/base/*.h
%{_includedir}/absl/crc/internal/*.h
%{_includedir}/absl/crc/*.h
%{_includedir}/absl/cleanup/internal/*.h
%{_includedir}/absl/cleanup/*.h
%{_includedir}/absl/container/internal/*.h
%{_includedir}/absl/container/*.h
%{_includedir}/absl/debugging/internal/*.h
%{_includedir}/absl/debugging/internal/*.inc
%{_includedir}/absl/debugging/*.h
%{_includedir}/absl/debugging/*.inc
%{_includedir}/absl/flags/internal/*.h
%{_includedir}/absl/flags/*.h
%{_includedir}/absl/functional/internal/*.h
%{_includedir}/absl/functional/*.h
%{_includedir}/absl/hash/internal/*.h
%{_includedir}/absl/hash/*.h
%{_includedir}/absl/log/internal/*.h
%{_includedir}/absl/log/*.inc
%{_includedir}/absl/log/*.h
%{_includedir}/absl/memory/*.h
%{_includedir}/absl/meta/*.h
%{_includedir}/absl/numeric/internal/*.h
%{_includedir}/absl/numeric/*.h
%{_includedir}/absl/numeric/*.inc
%{_includedir}/absl/profiling/internal/*.h
%{_includedir}/absl/random/internal/*.h
%{_includedir}/absl/random/*.h
%{_includedir}/absl/status/internal/*.h
%{_includedir}/absl/status/*.h
%{_includedir}/absl/strings/internal/*.h
%{_includedir}/absl/strings/internal/str_format/*.h
%{_includedir}/absl/strings/*.h
%{_includedir}/absl/synchronization/internal/*.h
%{_includedir}/absl/synchronization/*.h
%{_includedir}/absl/time/internal/cctz/include/cctz/*.h
%{_includedir}/absl/time/internal/cctz/src/*.h
%{_includedir}/absl/time/internal/*.h
%{_includedir}/absl/time/internal/*.inc
%{_includedir}/absl/time/*.h
%{_includedir}/absl/utility/internal/*.h
%{_includedir}/absl/utility/*.h
%{_includedir}/absl/types/internal/*.h
%{_includedir}/absl/types/*.h
%{_libdir}/libabsl_*.so.*
%{_libdir}/cmake/absl/*.cmake
%{_libdir}/pkgconfig/absl_*.pc

#=============================================================================
%prep
%setup -q
%patch -P 0 -p1

#-----------------------------------------------------------------------------
#building application
%build

cmake	 $CMAKE_FLAGS						\
	-B _bld							\
	-G Ninja						\
	-D CMAKE_BUILD_TYPE=RelWithDebInfo			\
	-D CMAKE_CXX_FLAGS="${CXXFLAGS} -DNDEBUG"		\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}			\
	-D CMAKE_CXX_STANDARD=17 				\
	-D BUILD_SHARED_LIBS=ON 				\
	-D ABSL_PROPAGATE_CXX_STD=ON				\
	-D ABSL_BUILD_TEST_HELPERS=ON				\
	-D ABSL_USE_EXTERNAL_GOOGLETEST=ON 			\
	-D ABSL_FIND_GOOGLETEST=ON 				\
	-D ABSL_BUILD_TESTING=ON				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
ninja 								\
	-C _bld							\
	%{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
#cd _bld
#ctest

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	ninja						\
	-C _bld						\
	install


#-----------------------------------------------------------------------------
%changelog
